//
//  HelloAqKanji2KoeAppDelegate.m
//  HelloAqKanji2Koe
//
//  Created by yamazaki on 11/02/04.
//  Modified by yamazaki on 2017/11/25 for Ver.3
//  Copyright 2017 AQUEST All rights reserved.
//

#import "HelloAqKanji2KoeAppDelegate.h"
#import <AqKanji2Koe/AqKanji2Koe.h>
#import <AqUsrDic/AqUsrDic.h>

@implementation HelloAqKanji2KoeAppDelegate

@synthesize window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// Insert code here to initialize your application 

	// 開発ライセンスキーの指定。評価版の制限が無くなり、製品版として動作する
	int iret = AqKanji2Koe_SetDevKey("XXX-XXX-XXX"); 
}


- (IBAction)convKanji2Koe:(id)sender
{
	// 辞書データのディレクトリパス取得(HelloAqKanji2Koe.app/Resourcesに辞書ファイルをおいた場合)
	NSBundle *bundle = [NSBundle mainBundle];
	NSString *path= [bundle resourcePath];
	const char *pathDic = [path UTF8String];
	
	// AqKAnji2Koeインスタンス生成
	int iErr;
	void *pAqK2K = AqKanji2Koe_Create(pathDic, &iErr);
		
	// テキストボックスから文字列取得
	NSString *strKoe = [textfieldKanji stringValue];
	
	// NSString文字列をC言語文字列(Utf8)に変換
	const char *kanji = [strKoe UTF8String];

	// 漢字かな交じり文を音声記号列に変換
	char koe[4096];
	AqKanji2Koe_Convert(pAqK2K, kanji, koe, 4096);
	
	// C言語文字列(Utf8)をNSStringに変換してテキストボックスへセット
	[textfieldKoe setStringValue:[NSString stringWithCString:koe encoding:NSUTF8StringEncoding]];
		
	// AqKAnji2Koeインスタンス解放
	if(pAqK2K) AqKanji2Koe_Release(pAqK2K);
}

- (IBAction)exportUsrDic:(id)sender {
	// 出力するCSVファイル名を取得
	NSSavePanel *savePanel	= [NSSavePanel savePanel];
    NSArray *allowedFileTypes = [NSArray arrayWithObjects:@"csv",@"'CSV'",nil];
    [savePanel setAllowedFileTypes:allowedFileTypes];
    NSInteger pressedButton = [savePanel runModal];
    if( pressedButton != NSModalResponseOK ) return;
	const char *pathDicCsv = [[[savePanel URL] path] UTF8String];

    // ユーザ辞書ファイルパス取得(HelloAqKanji2Koe.app/Resources/aq_user.dic)
    NSBundle *bundle = [NSBundle mainBundle];
    const char *pathUserDic = [[[bundle resourcePath] stringByAppendingString:@"/aq_user.dic"] UTF8String];

	// ユーザ辞書の内容をCSV出力
    int	iret = AqUsrDic_Export(pathUserDic, pathDicCsv);
    if(iret==0){
		NSAlert *alert = [[NSAlert alloc] init];
	    [alert setMessageText:@"CSVファイルのExport成功"];
        [alert runModal];
    }
	else {
		NSAlert *alert = [[NSAlert alloc] init];
	    [alert setMessageText:@"CSVファイルのExportエラー"];
        [alert runModal];
	}
}

- (IBAction)importUsrDic:(id)sender {
	// 入力のCSVファイル名を取得
	NSOpenPanel *openPanel	= [NSOpenPanel openPanel];
    NSInteger pressedButton = [openPanel runModal];
    if( pressedButton != NSModalResponseOK ) return;
	const char *pathDicCsv = [[[openPanel URL] path] UTF8String];

    // ユーザ辞書ファイルパス取得(HelloAqKanji2Koe.app/Resources/aq_user.dic)
    NSBundle *bundle = [NSBundle mainBundle];
    const char *pathUserDic = [[[bundle resourcePath] stringByAppendingString:@"/aq_user.dic"] UTF8String];

	// CSVファイルからユーザ辞書 aq_user.dicを生成
    int	iret = AqUsrDic_Import(pathUserDic, pathDicCsv);
    if(iret==0){
		NSAlert *alert = [[NSAlert alloc] init];
	    [alert setMessageText:@"CSVファイルのImport成功"];
        [alert runModal];
    }
	else {
		NSAlert *alert = [[NSAlert alloc] init];
	    [alert setMessageText:@"CSVファイルのImportエラー"];
        [alert runModal];
	}
}
@end
